from flask import Flask, request, render_template
from checker import ExpressionChecker
from worker import timeout
import ast

app = Flask(__name__)


@app.route("/")
def index():
    return render_template("index.html")


checker = ExpressionChecker()

@app.route("/api/calculate", methods=["POST"])
def calculate():
    """  try:
        expression = request.json().get("expression", "")
    except:
        return "request is not json?"
    """

    expression = request.get_json().get("expression", "")

    if not expression:
        return "empty expression"

    try:
        tree = ast.parse(expression)
    except:
        return "error on compile"

    try:
        checker.visit(tree)
    except Exception as exception:
        return str(exception)

    try:
        return str(eval_with_timeout(expression))
    except:
        return "error on expression"

@timeout(0.1)
def eval_with_timeout(expression):
    return eval(expression)


if __name__ == "__main__":
    app.run(port=5000, debug=True)